<?php

require_once( 'Config.php' );
require_once( 'Smarty.class.php' );
$friendConf = '/etc/friend.conf';

$c = new Config();

if ( PEAR::isError( ($ret = $c->parseConfig( $friendConf, 'GenericConf' ))) ) {
	echo 'Error: ' . $ret->getMessage() . '<br />';
	exit( 0 );
}
$root =& $ret;
$config = $root->toArray();


$smarty = new Smarty();
$smarty->debugging = false;
$smarty->template_dir = '/etc/smarty/templates';
$smarty->compile_dir = '/etc/friend/smarty/templates_c';
$smarty->cache_dir = '/etc/smarty/cache';
$smarty->config_dir = '/etc/smarty/configs';


$FRIENDERR_needmoredata = $xmlrpcerruser + 1;
$FRIENDERR_badcontact = $xmlrpcerruser + 2;
$FRIENDERR_dberr	= $xmlrpcerruser+ 3;
$FRIENDERR_baddatatype = $xmlrpcerruser + 4;
$FRIENDERR_toomuchdata = $xmlrpcerruser + 5;
$FRIENDERR_notauthorized = $xmlrpcerruser + 6;

$needmoredata = 'At least one e-mail address needs to be provided.';
$badcontact = 'The service contact needs to be in the ' .
	$config[ 'root' ][ 'realm' ] . ' realm.';
$dberr = 'There was a problem connecting to the Friend DB!';
$baddatatype = 'All provided e-mail addresses must be string values.';
$toomuchdata = "Only " . $config[ 'root' ][ 'maxinvites' ] . "invites are allowed to be sent at once.";
$notauthorized = 'This client not authorized to ask questions.';


		function
generateNewPin() {
	for ( $i = 0; $i < 6; $i++ ) {
		$pin .= chr( rand( 0, 255 ) );
	}
	$pin = base64_encode( $pin );
	// We want to void having + in the URL.
	if ( strpos( $pin, '+' ) !== false ) {
		return( generateNewPin() );
	}
	return( $pin );
}

		function
isGoodPasswd( $passwd ) {
	$config = $GLOBALS[ 'config' ];
    // passwd gets points for lower/upper case, digits, and punctuation
	$score = 0;   
	if ( ereg( "[[:lower:]]", $passwd )) {
		$score++;
	}

	if ( ereg( "[[:upper:]]", $passwd )) {
		$score++;
	}                 

	if ( ereg( "[[:digit:]]", $passwd )) {
		$score++;
	}
	if ( ereg( "[[:punct:]]", $passwd )) {
		$score++;
	}

	// XXX set minimum score in conf file
	if ( strlen( $_POST[ 'passwd0' ] ) >= $config[ 'root' ][ 'minpasswdlength' ] && $score >= $config[ 'root' ][ 'minpasswdscore' ] ) {
		return( true );
	}
	return( false );

}

       function
getFriendStatus( $a, $db ) {
	//-2, DB error
	//-1, bad e-mail address
	// 0, account does not exist
	// 1, account exists, 'friend'
	// 2, account exists and reset requested.
	// 3, account exists, PIN still good, password not set.
	// 4, account exists, but PIN expired, password not set.
	$config = $GLOBALS[ 'config' ];

	if ( !$db ) {
		return( -2 );
	}
	//check for valid e-mail RFC 822 address
	if ( !Mail_RFC822::isValidInetAddress( $a ) ) {
		return( -1 );
	}
	//Don't allow addresses that are in the configured realm.
	if ( preg_match( "/@.*\.?" . $config[ 'root' ][ 'realm' ] . "$/i", $a )) {
		return( -1 );
	}
	if ( get_magic_quotes_gpc() ) {
		$a = stripslashes( $a );
	}
	$a = mysql_real_escape_string( $a );
	//check if account is in Friend DB
	$result = mysql_query( "SELECT pin, passwd, UNIX_TIMESTAMP( last_modified ) FROM friend where login = '$a'", $db );
	if ( !$result ) {
		error_log( 'Friend: Could not SELECT from friend DB: ' . mysql_error() );
		return( -2 );
	}
	switch ( mysql_num_rows( $result ) ) {
	case 0 :
		return( 0 );
	case 1 :
		$row = mysql_fetch_array( $result, MYSQL_NUM );
		if ( $row[ 0 ] ) {
			if ( $row[ 1 ] ) {
				//pin and password set means account is being reset
				return( 2 );
			}
			//No password is set.  Check to see if pin expired.
			if ( ( $row[ 2 ] + $config[ 'root' ][ 'pinlife' ] ) > time() ) {
				//PIN is still good
				return( 3 );
			}
			//PIN expired, no password set
			return( 4 );
		}
		//No pin set + account == account exists.
		//NOTE: If no PIN and no PASSWORD set, your DB is corrupt.
		return( 1 );
	default :
		error_log( "Friend: Too many rows found in friend DB for account $a." );
		return( -2 );
	}

}

?>
